import FirebaseApi from "./FirebaseApi";
import { Bindable } from "bindable-bloc";
import { FBDocumentSnapshot, FBDocumentReference } from "./FirebaseTypes";
import { IStreamableDataApi } from "yuni-chanz-react";
export default abstract class FirebaseStreamableDataApi<T> extends FirebaseApi<T | null> implements IStreamableDataApi<T> {
    readonly streamedData: Bindable<T | null>;
    private streamCanceller;
    request(): Promise<T | null>;
    startStream(): void;
    stopStream(): void;
    /**
     * Returns the query used for streaming.
     */
    protected abstract getReference(): FBDocumentReference;
    /**
     * Parses the specified document snapshot into model T.
     */
    protected abstract parseData(snapshot: FBDocumentSnapshot): T;
    /**
     * Event called when the new stream of data has been received.
     */
    private onSnapshot;
}
