import { Bindable } from "bindable-bloc";
import { IStreamableQueryApi } from "yuni-chanz-react";
import FirebaseApi from "./FirebaseApi";
import { FBQueryDocumentSnapshot, FBQuery } from "./FirebaseTypes";
export default abstract class FirebaseStreamableQueryApi<T = any> extends FirebaseApi<T[]> implements IStreamableQueryApi<T> {
    readonly streamedData: Bindable<T[]>;
    private streamCanceller;
    request(): Promise<T[]>;
    startStream(): void;
    stopStream(): void;
    /**
     * Returns the query used for streaming.
     */
    protected abstract getQuery(): FBQuery;
    /**
     * Parses the specified document snapshot into model T.
     */
    protected abstract parseData(snapshot: FBQueryDocumentSnapshot): T;
    /**
     * Event called when the new stream of data has been received.
     */
    private onSnapshot;
}
